include "programming_language.dfy"
include "assertions.dfy"
include "inference_rules.dfy"
include "util.dfy"

module concurrent_example_spec {
    import opened programming_language
    import opened assertions
    import opened inference_rules
    import opened util

    function R(): Action {
        Action.Or(Change(p(), q()), Id())
    }

    function G(): Action {
        R()
    }

    function I(): Assertion {
        Assertion.And(Own("x"), emp_h)
    }

    function p(): Assertion {
        AndFromSeq([
            Own("x"),
            Bool(GreaterEqual(Var("x"), LVar("Y"))),
            emp_h
        ])
    }

    function C(): Stmt {
        Assign("x", Add(Var("x"), Int(1)))
    }

    function C'(): Stmt {
        Atomic(True, C())
    }

    function q(): Assertion {
        AndFromSeq([
            Own("x"),
            Bool(Greater(Var("x"), LVar("Y"))),
            emp_h
        ])
    }

    function p1(): Assertion {
        Assertion.Exists("X",
            AndFromSeq([
                Own("x"),
                Bool(Equal(LVar("X"), Add(Var("x"), Int(1)))),
                Bool(Greater(LVar("X"), LVar("Y"))),
                emp_h
            ])
        )
    }

    function p2(): Assertion {
        AndFromSeq([
            Own("x"),
            Bool(Equal(LVar("X"), Add(Var("x"), Int(1)))),
            Bool(Greater(LVar("X"), LVar("Y"))),
            emp_h
        ])
    }

    function p3(): Assertion {
        Assertion.Indep(
            AndFromSeq([
                Own("x"),
                Bool(Equal(LVar("X"), Add(Var("x"), Int(1)))),
                emp_h
            ]),
            Assertion.And(Bool(Greater(LVar("X"), LVar("Y"))), emp_s)
        )
    }

    function p4(): Assertion {
        AndFromSeq([
            Own("x"),
            Bool(Equal(LVar("X"), Add(Var("x"), Int(1)))),
            emp_h
        ])
    }


    function q4(): Assertion {
        AndFromSeq([
            Own("x"),
            Bool(Equal(Var("x"), LVar("X"))),
            emp_h
        ])
    }

    function q3(): Assertion {
        Assertion.Indep(
            AndFromSeq([
                Own("x"),
                Bool(Equal(Var("x"), LVar("X"))),
                emp_h
            ]),
            Assertion.And(Bool(Greater(LVar("X"), LVar("Y"))), emp_s)
        )
    }

    function q2(): Assertion {
        AndFromSeq([
            Own("x"),
            Bool(Equal(Var("x"), LVar("X"))),
            Bool(Greater(LVar("X"), LVar("Y"))),
            emp_h
        ])
    }

    function q1(): Assertion {
        Assertion.Exists("X",
            AndFromSeq([
                Own("x"),
                Bool(Equal(Var("x"), LVar("X"))),
                Bool(Greater(LVar("X"), LVar("Y"))),
                emp_h
            ])
        )
    }

// */
}
