module util {

    function domain<u, v>(m: map<u,v>): set<u>
        ensures forall i :: i in domain(m) <==> i in m;
    {
        set s | s in m
    }

    function setFromSeq<T>(se: seq<T>): set<T>
        ensures forall i :: i in se <==> i in setFromSeq(se)
    {
        set s | s in se
    }

    function union<u, v>(m: map<u,v>, m': map<u,v>): map<u,v>
        requires m !! m';
        ensures forall i :: i in union(m, m') <==> i in m || i in m';
        ensures forall i :: i in m ==> union(m, m')[i] == m[i];
        ensures forall i :: i in m' ==> union(m, m')[i] == m'[i];
    {
        map i | i in (domain(m) + domain(m')) :: if i in m then m[i] else m'[i]
    }

    function abs(n: int): int
        ensures abs(n) >= 0
    {
        if n > 0 then n else -n
    }
}
