include "programming_language.dfy"
import opened 'r46372 = programming_language

lemma Example_Cons(s0: Store, s1: Store, h0: Heap, h1: Heap)
    requires 0 !in h0 && 1 !in h0 && 2 !in h0
    requires h1 == h0[0 := 5][1 := 4][2 := 3]
    requires s1 == s0["x" := 0]
    ensures InstrStep(Cons("x", [Nat(5), Nat(4), Nat(3)]), (s0, h0), (s1, h1));
{
    var m0 := (s0, h0);
    var m1 := (s1, h1);
    var se := [Nat(5), Nat(4), Nat(3)];

    calc <== {
        InstrStep(Cons("x", se), m0, m1);
        exists addr :: 0 <= addr && ConsHelper(addr, se, s0, h0, h1);
        {assert ConsHelper(0, se, s0, h0, h1);}
        true;
    }
}

lemma Example1(s: Store, t: Store)
    requires t == s["x" := 5]["y" := 5]
    ensures StmtStep(
        Compose(
            Instr(Assign("x", Nat(5))),
            Instr(Assign("y", Var("x")))
        ), (s, map[]), (t, map[]))
{
    var s' := s["x" := 5];
    var m0 := (s, map[]);
    var m' := (s', map[]);
    var m1 := (t, map[]);
    calc {
       StmtStep(Compose(Instr(Assign("x", Nat(5))),
               Instr(Assign("y", Var("x")))), m0, m1);
       <==
       StmtStep(Instr(Assign("x", Nat(5))), m0, m') &&
               StmtStep(Instr(Assign("y", Var("x"))), m', m1);
       <==
       true;
    }
}


