module util {

   function domain<U, V>(m: map<U,V>): set<U>
      ensures forall i :: i in domain(m) <==> i in m;
   {
      set s | s in m
   }

   function union<U, V>(m: map<U,V>, m': map<U,V>): map<U,V>
      requires m !! m';
      ensures forall i :: i in union(m, m') <==> i in m || i in m';
      ensures forall i :: i in m ==> union(m, m')[i] == m[i];
      ensures forall i :: i in m' ==> union(m, m')[i] == m'[i];
   {
      map i | i in (domain(m) + domain(m')) :: if i in m then m[i] else m'[i]
   }
}
